/*
 *
 * Copyright (C)  1996 2000 Jochen Karrer 	
 * LinuxData GbR
 *
 */

#include "mv1.h"
#include "math.h"
#include <sys/time.h> 

#define ADC_TYPE (1<<8)
int
MV1_Is10Bit(MV1_Ctrl *ctrl){
	return 0;
//	u_int config = MV1_ConfigInw(ctrl);
//	return !(config & ADC_TYPE);
}

/* 4.2 Camera Control Setup */

/*
 * -----------------------------------------------------------
 *
 * MV1SelectSTDCameraConfig 
 *	Selects one of the Standard camera configurations
 *	((This does not include the default setting for
 *	sync Gen to generate external Sync ))
 *
 * -----------------------------------------------------------
 */ 
int 
MV1_SelectSTDCameraConfig(MV1_CamConfig *camcfg,u_short cflag){
	camcfg->videoChannel = 1;
	camcfg->syncChannel = 3;
	camcfg->ClampControl = 1;
	camcfg->ADTop = 102;
	camcfg->ADBottom = 31;
	camcfg->ClampLevel = 61;
	camcfg->DCOffset = 0x0;
	
	camcfg->filterCutoff = 127;
	camcfg->filterBoost = 0;

	camcfg->pll.clockReference = 0;
	
	if(cflag == MV1_RS170_Cam) {
		camcfg->hOffset = 0x72;
		camcfg->vOffset = 0x10;
		camcfg->pll.PixelPerLine = 0x38e;
		camcfg->pll.hPeriod = 63.55600;	
		camcfg->pll.PhaseTriming = 0;

		// Sync generator 
		camcfg->cameraInterlace = 1;
		camcfg->cameraDriveWidth = 0x67;
		camcfg->cameraDriveHeight = 0x3;
		camcfg->cameraPixelPerLine = 0x38e;
		camcfg->cameraLinePerFrame = 525;
		camcfg->cameraDriveVPolarity = 0;
		camcfg->cameraDriveHPolarity = 0;
		
		
		camcfg->externalTrigger = 0;
		camcfg->externalTriggerPolarity = 0;
		camcfg->externalClock = 0;
		camcfg->flagInterlace = 1;
		camcfg->Start_Field = 0;
		camcfg->externalClock=0;     	/* Pixel Clock  */
                camcfg->Flag_DigitalCamera=0;
                camcfg->Flag_Video_AC_Couple=1;
                camcfg->Flag_Sync_DC_Couple=1; 
                camcfg->Flag_Sync_Termination=0;
                //      bitPerPixel;
                camcfg->bitmode=0; 		// Shiftdown = 0
                // camcfg->lineScanCamera;
                camcfg->External_Sync_Input=0;
                camcfg->External_CSync_Input=1; // 1 = Separate C. Sync input us
                                                // 0 = Separate H + V Sync input
                camcfg->HSync_Polarity = 0;
                camcfg->MaxCaptureSizeH = 0x280;
                camcfg->MaxCaptureSizeV = 0x1e0;

	}
	else if(cflag == MV1_CCIR_Cam){
		camcfg->hOffset = 0x9a;
        	camcfg->vOffset = 0x14;
		camcfg->pll.PixelPerLine = 945; // (945) is this CCIR ? 
		camcfg->pll.hPeriod = 64;
		camcfg->pll.PhaseTriming = 0x0;

		// Sync generator		
		camcfg->cameraInterlace = 1;
		camcfg->cameraDriveWidth = 0x67;
		camcfg->cameraDriveHeight = 0x3;
		camcfg->cameraPixelPerLine = 0x38e;
		camcfg->cameraLinePerFrame = 576;//0x20d; ????? 
		camcfg->cameraDriveVPolarity = 0;
		camcfg->cameraDriveHPolarity = 0;

		camcfg->externalTrigger = 0;
		camcfg->externalTriggerPolarity = 0;
		camcfg->externalClock = 0;
		camcfg->flagInterlace = 1;
		camcfg->Start_Field = 0;
		camcfg->externalClock=0;     /* Pixel Clock  */
         	camcfg->Flag_DigitalCamera=0;
        	camcfg->Flag_Video_AC_Couple=1;
        	camcfg->Flag_Sync_DC_Couple=1; // 1 = AC says ccir768.ini
        	camcfg->Flag_Sync_Termination=0;
        	//	bitPerPixel;
         	camcfg->bitmode=0; // Shiftdown = 0
        	// camcfg->lineScanCamera;
        	camcfg->External_Sync_Input=0;
        	camcfg->External_CSync_Input=1; // 1 = Separate C. Sync input used
                                 		// 0 = Separate H + V Sync input used
		
        	camcfg->HSync_Polarity = 0;
		camcfg->MaxCaptureSizeH = 0x300;
        	camcfg->MaxCaptureSizeV = 0x23f;

	}
	return 0;

}

/*
 * --------------------------------------------------------------------
 *
 * MV1_SetCameraConfig
 *	Load a set of camera configuration parameters into the mv-1000:
 *	video Selection
 *	grab windows
 *	video conditioning
 *	filter operation
 *	Pll Control
 *	camera drive command
 *	Sync strip
 *	...
 * --------------------------------------------------------------------
 */
int 
MV1_SetCameraConfig(MV1_CamConfig *cfg,MV1_Ctrl *ctrl){
		
	/*	video selection	*/
	MV1_SetCVideoSource(cfg->videoChannel,ctrl);
	MV1_SetCSyncSource(cfg->syncChannel,ctrl);
	
	/*	grab windows */
	MV1_SetHStart(cfg->hOffset,ctrl);
	MV1_SetVStart(cfg->vOffset,ctrl);


	/*	video Conditioning	*/
	MV1_SelectClamping(cfg->ClampControl,ctrl);
	MV1_SetDigitizeLevel(cfg->ADTop,cfg->ADBottom,ctrl);
	MV1_SetClampLevel(cfg->ClampLevel,ctrl);
	MV1_SetDCOffset(cfg->DCOffset,ctrl);

	/*	filter operation 	*/
	MV1_SetFilterCutoff(cfg->filterCutoff,ctrl);
	MV1_SetHighFreqBoost(cfg->filterBoost,ctrl);
	
	/* 	PLL Control	*/
	MV1_SetPLLControl(&cfg->pll,ctrl);
	

	/*	Camera drive control	*/
	// LM1882 not fully supported for now
 		// cfg->cameraInterlace 
                // cfg->cameraDriveWidth // fixed for now to RS170 values
                // cfg->cameraDriveHeight // fixed for now	
	LM1882_SetLinePerFrame(cfg->cameraLinePerFrame,ctrl);
	LM1882_SetPixelPerLine(cfg->cameraPixelPerLine,ctrl);
        LM1882_SelectVCSyncPolarity(cfg->cameraDriveVPolarity,ctrl);
        LM1882_SelectHSyncPolarity(cfg->cameraDriveHPolarity ,ctrl);

	/* 	Sync	strip must be calculated before used		*/
	{
		double rangetab[] = {  5000,10000,
				      10000,20000,
				      20000,40000,
				      40000,64000 };
		int i = 0;
		while(i<4) {
			double hPeriod = 1e-6*cfg->pll.hPeriod;
			double max = 1/rangetab[(i<<1)];
  			double min = 1/rangetab[(i<<1)+1];
			if( (hPeriod <= max) && (hPeriod >=min))
				break;
			i++;
		}
                if(i<4)
                        MV1_SelectSyncStripRange(i,ctrl);
                else
                        fprintf(stderr,"illegal horiz. period: %f\n",cfg->pll.hPeriod);
        }
	
	/* misc */	
	MV1_SetExtTriggerMode(cfg->externalTrigger,cfg->externalTriggerPolarity,ctrl);
	MV1_SetInterlace(cfg->flagInterlace,ctrl);
	MV1_SetStartField(cfg->Start_Field,ctrl);
	// externalClock (Pixelclock); 
	if(cfg->Flag_DigitalCamera) {

	}
	// Flag_Video_AC_Couple
	// Flag_Sync_DC_Couple
	// Flag_Sync_Termination;
	// bitPerPixel;
	MV1_SelectADConvertor(cfg->bitmode,ctrl); // Shift down 2Bit or not, has no effect for 8Bit Version
        // lineScanCamera;
        // External_Sync_Input;
        // External_CSync_Input;
        // HSync_Polarity;

	MV1_SetHEnd(cfg->MaxCaptureSizeH + cfg->hOffset,ctrl);
	MV1_SetVEnd(((cfg->MaxCaptureSizeV+cfg->flagInterlace)>>cfg->flagInterlace) 
		+ cfg->vOffset,ctrl);
	return 0;
}

/* 
 *
 * MV1InquireCameraConfig
 *	Returns parameters for the currently selected mv1000 board
 *
 */
int 
MV1InquireCameraConfig(MV1_CamConfig *camConfig);


/*
 *
 */
int
MV1_SetPLLControl(MV1_PLLSyncCtl *pll,MV1_Ctrl *ctrl) {
	int outps = 3; 			// don't divide output by default 
	//float hfreq = (pll->PixelClockFreq*1e6)/pll->PixelPerLine;			
	int fbkdiv=0;
	int refdiv=0;

        MV1_SetPLLPhaseTrim(pll->PhaseTriming,ctrl);
        MV1_SelectClockSource(pll->clockReference,ctrl);
        ICS_SetLeadLag(pll->LeadLag,ctrl);

	if((pll->clockReference == MV1_CSyncClock)||(pll->clockReference == MV1_ExtHSyncClock)){
		fbkdiv = pll->PixelPerLine; 	// Multiply hsync with PixelPerLine
		refdiv = 1;		
	}
	
		// Find best aproximation for a given frequency

	else if((pll->clockReference == MV1_14MHz)) {
		if(pll->PixelClockFreq >= 14.318 ) {

			float ratio = pll->PixelClockFreq/14.318;
			fbkdiv = ratio+0.5;
			refdiv = 1;
		}
		else {
			float ratio = 14.318 / pll->PixelClockFreq;
			fbkdiv = 1*64;
			refdiv = ratio*64+0.5;
			//fprintf(stderr,"not imp %s,%d\n",__FILE__,__LINE__);
		}
		while(fbkdiv < 64) { // what about max Phase FD input Freq ?
			fbkdiv <<=1;
			refdiv <<=1;
		}	
	}
	else if(pll->clockReference == MV1_ExtClock){
		refdiv = fbkdiv = 64;  	// 64 = minimal fbkdiv
					// What if camera gives 2*Pixelclock ?
	}
	else {
		fprintf(stderr,"invalid clock Source given: %s line %d\n",__FILE__,__LINE__);
	}
	/* 
	  Frequency range of the ICS-1522 VCO is 14-230 MHz
	  if frequency is lower use divider
	*/
//	if((pll->PixelClockFreq < 14.0) && (pll->PixelClockFreq > 7.0) ) {
//		outps = 2; 		// divide output by 2 
//		if(fbkdiv <= (2048>>1)) {
//			fbkdiv <<= 1;
//		}
//		else if((refdiv & ((1<<1)-1)) == 0) {
//			refdiv >>= 1; 
//		}
//		else fprintf(stderr,"problem with PLL-fbkdiv/refdiv in %s in line %d\n",__FILE__,__LINE__);
//		return -1;
//	}
//	else if(pll->PixelClockFreq > 3.5) { 
//		outps=1;	// divide output by 4;
//		if(fbkdiv <= (2048>>2)) {
//                       fbkdiv <<= 2;
//              }
//                else if((refdiv & ((1<<2)-1)) == 0) {
//                       refdiv >>= 2;
//                }
//                else fprintf(stderr,"problem with PLL-fbkdiv/refdiv in %s in line %d\n",__FILE__,__LINE__);
//                return -1;
//	}
//	else fprintf(stderr,"problem with PLL-fbkdiv/refdiv in %s in line %d\n",__FILE__,__LINE__);
	/*
	 *	Frequency range of the PHASE-FREQUENCY-DETECTOR ist 15-100kHz ?
         */

	ICS_SetFbkDiv(fbkdiv,ctrl);
	ICS_SetRefDiv(refdiv,ctrl);
	ICS_SetPDA(outps,ctrl);

	// PixelPerLine;
        // hperiod
        // forceEQRemove 
        // PixelClockFreq

	return 0;
}

extern int
MV1_SetDigitizeLevel(int top_ref, int bottom_ref,MV1_Ctrl *bd){
	MV1_SetADTopLevel(top_ref,bd);
	MV1_SetADBottomLevel(bottom_ref,bd);
	return 0;
}


int 
MV1_GetOffsetRange(float *low, float *high){
	return -1;
}


/* 4.3 External Control */ 

extern int 
MV1_SetExtTriggerMode(int t_flag, int t_polar,MV1_Ctrl *ctrl){
	MV1_SetExtTrigger(t_flag,ctrl);
	return MV1_SetTriggerPolarity(t_polar,ctrl);
}

/*
 *	offset is the startaddress in the VRAM
 *	sx is the hoffset and sy the voffset
 *	dx,dy is the size of the grab win.
 *	result will be stored in the GrabWin struct
 */
int 
MV1_CreateGrabWindow(u_long offset, u_long sx,u_long sy,
        u_long dx,u_long dy, MV1_GrabWindow *gW,MV1_Ctrl *bd){
	gW->startaddr = offset;
	gW->sx = sx;
	gW->sy = sy;
	gW->dx = dx;
	gW->dy = dy;
	return MV1_OK;
}
int MV1_SetGrabWindow(MV1_GrabWindow *gw,MV1_Ctrl *bd){
	// MV1_SetStartAddr(gw->startaddr,bd);
	MV1_SetHStart(gw->sx,bd);
	MV1_SetHEnd(gw->sx + gw->dx,bd);
	MV1_SetVStart(gw->sy,bd);
	MV1_SetVEnd(gw->sy+gw->dy,bd);
	return ioctl(bd->raw_fd,MV1_SET_GRAB_WINDOW,gw);
}
int 
MV1_InquireGrabWindowSize(u_long *dx,u_long *dy,MV1_Ctrl *ctrl){
	*dx = MV1_InquireHEnd(ctrl) - MV1_InquireHStart(ctrl); 
	*dy = MV1_InquireVEnd(ctrl) - MV1_InquireVEnd(ctrl);
	return 0;
}
int 
MV1_CreateMaxFrame(MV1_Frame *frame,MV1_GrabWindow *gw){
	frame->dx = gw->dx;
	frame->dy = gw->dy;
	frame->sx = 0;
	frame->sy = 0;
	return 0;
}


int 
MV1_CreateFrame(MV1_Frame *frame,u_long sx,u_long sy,u_long dx,u_long dy,
        MV1_GrabWindow *gW,MV1_Ctrl *bd){
	if(sx < gW->sx) {
		dx -= gW->sx - sx;
		sx = gW->sx;
	}
	if(sy < gW->sy) {
		dy -= gW->sy -sy;
                sy = gW->sy;
        }
	if( (sx+dx) > (gW->sx+gW->dx) ) {
		dx = gW->dx - sx;
	}
	if( (sy+dy) > (gW->sy+gW->dy) ) {
		dy = gW->dy-sy;
	}
	frame->sx = sx;
	frame->sy = sy;
	frame->dx = dx;
	frame->dy = dy;
	return MV1_OK;
}


/* 4.6 Look Up Table Operations */

extern int    
MV1_LutWriteValue(u_long value,u_long addr,u_long lut,MV1_Ctrl *ctrl) {
        u_long a[]={value,addr,lut};
        return ioctl(ctrl->ctrl_fd,MV1_LUT_WRITE_VALUE,a);
}
extern 
int MV1_LoadLutDefault(int flag,MV1_Ctrl *ctrl) {
        int i,j;
        int lut = MV1_InquireLutBank(ctrl);
        for(i=0;i<256;i++){
                if(flag) j = 255-i;
                else j=i;
                j = (j<<8)+(j<<16)+(j<<24)+j;
                MV1_LutWriteValue(i+(i<<8)+(i<<16)+(i<<24), j,lut ,ctrl);
        }
        return 0;
}


int 
MV1_Write8BitLut(u_long *pixeltab, int lut, MV1_Ctrl *bd) {
	int i;
	u_long val[256],adr[256];
	//u_long *val = 0,*adr=1000;
	u_long args[] = {(u_long)val,(u_long)adr,lut};
	if((lut==0) && (bd->lut0_locked)) {
                fprintf(stderr,"error: tried to write to locked global LUT !!!\n"
                "You should use MV1_UnlockGlobalLut(board) before !\n");
                return -1;
        }
	if((lut<1) || (lut>7))
                return -1;

	for(i=0;i<256;i++) {
		val[i] = pixeltab[i];
                adr[i] = i + (i << 8) + (i << 16) + (i << 24);
                val[i] = val[i] + (val[i] << 8) + (val[i] << 16) + (val[i] << 24);
	}
	i= ioctl(bd->ctrl_fd,MV1_WRITE_8BIT_LUT,args);
	if(i<0)
		perror("ioctl error writing lut");
//	else fprintf(stderr,"remaining %d jiffies\n",i);
	return i;
}
int
MV1_WriteSoftLut8_32(unsigned long *lut,MV1_Ctrl *bd) {
        int i;
        if(bd->lut10_32==NULL) {
                bd->lut10_32 = malloc(1024*4);
                if(bd->lut10_32==NULL)
                        return -1;
                bd->lut10_16 = malloc(1024*2);
                if(bd->lut10_16==NULL)
                        return -1;
        }
        for(i=0;i<256;i++) {
                bd->lut10_32[i]=lut[i];
                bd->lut10_16[i]=lut[i];
        }
        return MV1_OK;
}
/*
 * --------------------------------------------------------------------
 *
 * MV1_XImageRead
 *
 *      Read a frame from the MV-1000 and store in XImage format
 *
 * ---------------------------------------------------------------------
 */
int 
ximage16_read(MV1_Frame *frame, XImage *xim,MV1_Ctrl *bd) 
{
		static u_int16_t lut[256];
		int i;
		int count = frame->dx*frame->dy;
                u_short *data = (u_short*)xim->data;
		u_int32_t *vidline = ((u_int32_t*)bd->video_mem);
		for(i=0;i<256;i++) {
			lut[i] = bd->lut10_16[i];
		}
		for(i=0;i<count>>2;i++) {    
		    register union {
			u_int32_t ul;
			u_int8_t c[4];
		    } src;
		    register union {
			u_int32_t ul;
			u_int16_t s[2];
		    } dst; 
		    src.ul = *vidline;	
		    dst.s[0] = lut[src.c[0]];	
		    dst.s[1] = lut[src.c[1]];	
		    *((u_int32_t*)data) = dst.ul;

		    dst.s[0] = lut[src.c[2]];	
		    dst.s[1] = lut[src.c[3]];	
		    *(1+(u_int32_t*)data) = dst.ul;
		    data+=4;
		    vidline++;
		}
		return i*4;

}
int
MV1_XImageRead(MV1_Frame *frame, XImage *xim,MV1_Ctrl *bd){
        int i=0,j=0;
        if(xim->depth==8) {
                return MV1_FrameRead(frame,xim->data,bd);
        }
        else if(xim->depth == 16) {
                u_short *data = (u_short*)xim->data;
		u_char *vidline = ((u_char*)bd->video_mem);
//		struct timeval  tvv,tvn;
//		gettimeofday(&tvv,NULL);

		lseek(bd->raw_fd,0,SEEK_END);
		if(bd->raw_zoom) {
			int lines = frame->dy/2;
			int columns = frame->dx/2;
			for(j=0;j<lines;j++) {
                        	for(i=0;i<columns;i++) {
                            		*data++ = bd->lut10_16[*vidline];
					vidline+=2;	
                        	}
                        	vidline+=frame->dx;
			}      
		} else {
			i=ximage16_read(frame,xim,bd);
		}
//		gettimeofday(&tvn,NULL);
//		fprintf(stderr,"Differenz: %ld\n",tvn.tv_usec-tvv.tv_usec+1000000*(tvn.tv_sec -tvv.tv_sec));
        }
        return i;
}

void
MV1_UnlockGlobalLut(MV1_Ctrl *bd) {
        bd->lut0_locked=0;
}
int  
MV1_LutWrite(u_short startbin, u_short len, u_long *source,MV1_Ctrl *bd){
	int i;
	for(i=startbin;i<startbin+len;i++) {
		u_long adr = i + (i << 8) + (i << 16) + (i << 24);		
		MV1_LutWriteValue(*(source+i),adr,0,bd);
	}
	return MV1_OK;
}

  
/* 4.8 Image File Acess */

int MV1_PGMSaveCurrentFrame(char *fname,MV1_Ctrl *ctrl){
	FILE *file;
	char *buf;
	MV1_Frame frame;
	MV1_InquireFrame(&frame,ctrl);
	file = fopen(fname,"w");
	if(file == NULL) return -1;
	fprintf(file,"P5\n# MV1000\n%ld %ld\n255\n",frame.dx,frame.dy);
	buf = malloc(frame.dx*frame.dy);
	if(!buf) return -1;
	read(ctrl->raw_fd,buf,frame.dx*frame.dy);
	fwrite(buf,1,frame.dx*frame.dy,file);
	fflush(file);
	free(buf);
	return 0;
}

/*
 * -----------------------------------------------------------------
 *
 *      Master Transfer and Interrupt Handling
 *
 * ----------------------------------------------------------------
 */


int 
MV1_ConnectInterruptToCallback(int irqmask,void (*action)(int),MV1_Ctrl *ctrl) {
        struct sigaction act;
	if(irqmask) {
        	act.sa_handler = action;
	} else {
		act.sa_handler = SIG_IGN;
	}	
        memset(&act.sa_mask,0,sizeof(act.sa_mask));
        act.sa_restorer = NULL;
        act.sa_flags = 0;
        sigaction(SIGIO, &act, NULL);
	fcntl(ctrl->raw_fd,F_SETFL,FASYNC);
	fcntl(ctrl->raw_fd,F_SETOWN,getpid());;
	return 0;
}

/*
 *
 *
 *
 */
u_long
MV1_GetBusAddress(u_long adr,MV1_Ctrl *ctrl){
	u_long address = adr;
	ioctl(ctrl->ctrl_fd,GET_BUS_ADDRESS,&address);
	return address;
}

void *
MV1_MasterMalloc(u_long size,MV1_Ctrl *ctrl){
	
	void *mem;
	mem = (void *) mmap( (caddr_t) 0x0,size,
                PROT_READ | PROT_WRITE ,
                MAP_SHARED ,ctrl->raw_fd,0 );	
	if( ((int)mem) == -1) {
		perror("MasterMalloc");
		return NULL;
	}
	return mem;
}

void
MV1_Close(MV1_Ctrl *bd) 
{
        if(!bd)
                return;
        if(bd->lut10_32!=NULL)
                free(bd->lut10_32);

        if(bd->private_lut>=0)
                MV1_FreeLut(bd);

        if(bd->video_mem)
                munmap(bd->video_mem,4*1024*1024);

        if(bd->ctrl_fd>=0)
                close(bd->ctrl_fd);

        if(bd->raw_fd>=0) {
                close(bd->raw_fd);
        }
        free(bd);
}

MV1_Ctrl *
MV1_Open(int board_id) 
{
        MV1_Ctrl *ctrl = (MV1_Ctrl *)malloc(sizeof(MV1_Ctrl));
        if(ctrl == NULL) {
                fprintf(stderr,"out of memory\n");
                exit(1);
        }
        ctrl->raw_fd = open("/dev/mv1000",O_RDWR);
        if(ctrl->raw_fd<0){
                perror("can't open /dev/mv1000:");
                free(ctrl);
                return NULL;
        }
        ctrl->ctrl_fd = open("/dev/mv1000_ctrl",O_RDWR | O_NONBLOCK);
        if(ctrl->ctrl_fd<0){
                perror("can't open /dev/mv1000_ctrl");
                free(ctrl);
                return NULL;
	 }
#ifdef  EMULATE_ONLY
        { 
		int fd = open("/dev/zero",O_RDWR);
             	ctrl->video_mem = (u_long *) mmap( (caddr_t) 0x0,4*1024*1024,
                	PROT_READ | PROT_WRITE ,
                	MAP_SHARED ,fd,4*1024*1024 );
	}
#else
        ctrl->video_mem = (u_long *) mmap( (caddr_t) 0x0,1*1024*1024,
                PROT_READ | PROT_WRITE ,
                MAP_SHARED ,ctrl->raw_fd,1*1024*1024 );
#endif
        if(ctrl->video_mem < 0) {
         	perror("can't map videomem");
        }
	ctrl->lut0_locked=1;
	ctrl->raw_zoom=0;
	ctrl->private_lut=-1;
        ctrl->lut10_32 = NULL;
        return ctrl;

}
